/*
 * Copyright 2010, Jorma Karvonen, karvonen.jorma_at_gmail.com. All rights 
 * reserved. Distributed under the terms of the MIT License.
 */

#include "LocaleCatalog.h"

#include <Autolock.h>
#include <Locker.h>

#undef B_TRANSLATE_CONTEXT
#define B_TRANSLATE_CONTEXT "LocaleCatalog"


// static instance (created on first call to LocaleCatalog::Instance().)
LocaleCatalog* LocaleCatalog::s_instance = 0;
BLocker LocaleCatalog::s_instanceLock("LocaleCatalog::s_instanceLock");


LocaleCatalog::~LocaleCatalog() {}


/*
 * singleton access
 */
LocaleCatalog*
LocaleCatalog::Instance()
{
	BAutolock _l(s_instanceLock);
	if (!s_instance)
		s_instance = new LocaleCatalog();
	
	return s_instance;
}


/*
 * kill current instance if any
 */
void
LocaleCatalog::QuitInstance()
{
	BAutolock _l(s_instanceLock);
	if (s_instance)
		s_instance = 0;
}


/*
 * hidden constructor (use Instance() to access a single instance)
 */
LocaleCatalog::LocaleCatalog()
	:
	fAppCatalog(NULL)
{
	// TODO: here something else than be_locale should be called ?
	be_locale->GetAppCatalog(&fAppCatalog);
}


bool
LocaleCatalog::QuitRequested()
{
	return false;
}


void
LocaleCatalog::MessageReceived(BMessage* message)
{
  switch (message->what) {
	default:
		;
  }
}

